-- User Interface

local function L(x) return Translations.Equalizer.L(x) end

local context = nil
local configScreen = { built = false }
local buffWatcher = { built = false }

Equalizer.UI = {}

local populateHelplist
local helplistTarget
local playerID=nil

-- ==========================================================
-- ================ handle config screen ====================
-- ==========================================================

local function showHelplist()
	if populateHelplist then
		populateHelplist()
	end
end

local function buildConfigScreen()
	configScreen.mainWindow=UI.CreateFrame("SimpleWindow", "config", context)
	configScreen.mainWindow:SetCloseButtonVisible(true)
	configScreen.mainWindow:SetPoint("CENTER", UIParent, "CENTER", 0,0)
	configScreen.mainWindow:SetTitle(L("Equalizer Configuration: Role ")..Equalizer_Settings.currentRole)
	configScreen.mainWindow:SetWidth(700)
	function configScreen.mainWindow.Event:Close()
		-- print ("closing window")
		populateHelplist=nil
		helplistTarget=nil
		-- configScreen:SetKeyFocus(false)
	end
	
-------- Header
	configScreen.labelh1 = UI.CreateFrame("Text", "labelh1", configScreen.mainWindow:GetContent())
	configScreen.labelh1:SetText(L("Abilities to watch:"))
	configScreen.labelh1:SetFontSize(16)
	configScreen.labelh1:SetPoint("TOPLEFT", configScreen.mainWindow, "TOPLEFT", 20, 60)
-------- left side list of what we're watching
	configScreen.listScroll = UI.CreateFrame("SimpleScrollView", "bg", configScreen.mainWindow:GetContent())
	configScreen.listScroll:SetBackgroundColor(0.1,0.1,0.1,1)
	configScreen.listScroll:SetPoint("TOPLEFT", 	configScreen.labelh1, "BOTTOMLEFT", 0, 20)
	configScreen.listScroll:SetPoint("BOTTOMLEFT",	configScreen.mainWindow, "BOTTOMLEFT", 20, -100)
	configScreen.listScroll:SetWidth(350)

	configScreen.listContent = UI.CreateFrame("SimpleList", "List", configScreen.listScroll)
	configScreen.listContent:SetItems(Equalizer.Datamodel.getWatchlistStrings())
--	configScreen.listContent:SetSelectedIndex(1)		Postpone this so we can fill the right side widgets.
	configScreen.listScroll:SetContent(configScreen.listContent)
	function configScreen.listContent.Event:ItemSelect(item, value, index)
		-- print("index is "..(index or "nil"))
		if index ~= nil then
			definitions=Equalizer.Datamodel.getWatchListIndex(index)
			configScreen.selectwb:SetText(definitions.buff)
			configScreen.textms:SetText(tostring(definitions.stacks))
			configScreen.selectot:SetText(definitions.target)
			configScreen.selectab:SetText(definitions.ability)
			if definitions.isEmpty then
				configScreen.addButton:SetText(L("Add"))
			else
				configScreen.addButton:SetText(L("Save"))
			end
		end
	end	
-------- Header
	configScreen.labelh2 = UI.CreateFrame("Text", "labelh1", configScreen.mainWindow:GetContent())
	configScreen.labelh2:SetText(L("Edit marked Ability:"))
	configScreen.labelh2:SetFontSize(16)
	configScreen.labelh2:SetPoint("TOPLEFT", configScreen.labelh1, "TOPLEFT", 380, 0)
-------- watch which buff?
	configScreen.labelwb = UI.CreateFrame("Text", "labelwb", configScreen.mainWindow:GetContent())
	configScreen.labelwb:SetText(L("watch Buff:"))
	configScreen.labelwb:SetFontSize(14)
	configScreen.labelwb:SetPoint("TOPLEFT", configScreen.labelh2, "BOTTOMLEFT", 0, 10)
	
	configScreen.selectwb = UI.CreateFrame("RiftTextfield", "selectwb", configScreen.mainWindow:GetContent())
	configScreen.selectwb:SetPoint("TOPLEFT", configScreen.labelwb, "TOPLEFT", 150, 0)
	configScreen.selectwb:SetText("")
	configScreen.selectwb:SetHeight(20)
	configScreen.selectwb:SetWidth(130)
	configScreen.selectwb:SetBackgroundColor(0,0,0)
	function configScreen.selectwb.Event:KeyFocusGain()
		populateHelplist=Equalizer.UI.getListOfKnownBuffs
		helplistTarget=configScreen.selectwb
		showHelplist()
	end
-------- number of stacks
	configScreen.labelms = UI.CreateFrame("Text", "labelms", configScreen.mainWindow:GetContent())
	configScreen.labelms:SetText(L("maximum Stacks:"))
	configScreen.labelms:SetFontSize(14)
	configScreen.labelms:SetPoint("TOPLEFT", configScreen.labelwb, "BOTTOMLEFT", 0, 10)

	configScreen.textms = UI.CreateFrame("RiftTextfield", "textms", configScreen.mainWindow:GetContent())
	configScreen.textms:SetPoint("TOPLEFT", configScreen.labelms, "TOPLEFT", 150, 0)
	configScreen.textms:SetText("1")
	configScreen.textms:SetHeight(20)
	configScreen.textms:SetWidth(130)
	configScreen.textms:SetBackgroundColor(0,0,0)
	function configScreen.textms.Event:KeyFocusGain()
		populateHelplist=Equalizer.UI.emptyList
		helplistTarget=configScreen.textms
		showHelplist()
	end
-------- target to watch buffs on
	configScreen.labelot = UI.CreateFrame("Text", "labelot", configScreen.mainWindow:GetContent())
	configScreen.labelot:SetText(L("on unit:"))
	configScreen.labelot:SetFontSize(14)
	configScreen.labelot:SetPoint("TOPLEFT", configScreen.labelms, "BOTTOMLEFT", 0, 10)

	configScreen.selectot = UI.CreateFrame("RiftTextfield", "selectot", configScreen.mainWindow:GetContent())
	configScreen.selectot:SetPoint("TOPLEFT", configScreen.labelot, "TOPLEFT", 150, 0)
	configScreen.selectot:SetText("")
	configScreen.selectot:SetHeight(20)
	configScreen.selectot:SetWidth(130)
	configScreen.selectot:SetBackgroundColor(0,0,0)
	function configScreen.selectot.Event:KeyFocusGain()
		populateHelplist=Equalizer.UI.getListOfKnownTargets
		helplistTarget=configScreen.selectot
		showHelplist()
	end
-------- ability to use to recast buff
	configScreen.labelab = UI.CreateFrame("Text", "labelot", configScreen.mainWindow:GetContent())
	configScreen.labelab:SetText(L("ability to use"))
	configScreen.labelab:SetFontSize(14)
	configScreen.labelab:SetPoint("TOPLEFT", configScreen.labelot, "BOTTOMLEFT", 0, 10)

	configScreen.selectab = UI.CreateFrame("RiftTextfield", "selectab", configScreen.mainWindow:GetContent())
	configScreen.selectab:SetPoint("TOPLEFT", configScreen.labelab, "TOPLEFT", 150, 0)
	configScreen.selectab:SetText("")
	configScreen.selectab:SetHeight(20)
	configScreen.selectab:SetWidth(130)
	configScreen.selectab:SetBackgroundColor(0,0,0)
	function configScreen.selectab.Event:KeyFocusGain()
		populateHelplist=Equalizer.UI.getListOfKnownAbilities
		helplistTarget=configScreen.selectab
		showHelplist()
		local currentcontent=configScreen.selectab:GetText()
		if currentcontent == nil or currentcontent == "" then
			configScreen.selectab:SetText(configScreen.selectwb:GetText())
		end
		
	end
-------- help window
	configScreen.helpScroll = UI.CreateFrame("SimpleScrollView", "help", configScreen.mainWindow:GetContent())
	configScreen.helpScroll:SetBackgroundColor(0,0,0,1)
	configScreen.helpScroll:SetPoint("TOPLEFT", 	configScreen.labelot, "BOTTOMLEFT", 0, 60)
	configScreen.helpScroll:SetPoint("BOTTOMRIGHT",	configScreen.mainWindow, "BOTTOMRIGHT", -20, -100)

	configScreen.helpContent = UI.CreateFrame("SimpleList", "List", configScreen.listScroll)
	configScreen.helpContent:SetSelectedIndex(1)
	configScreen.helpScroll:SetContent(configScreen.helpContent)
	function configScreen.helpContent.Event:ItemSelect(item)
		if item ~= nil then
			helplistTarget:SetText(item)
			configScreen.helpContent:SetSelectedIndex(nil)
		end
	end
-------- buttons	
	configScreen.delButton = UI.CreateFrame("RiftButton", "rbdel", configScreen.mainWindow:GetContent())
	configScreen.delButton:SetText(L("Delete"))
	configScreen.delButton:SetPoint("TOPLEFT",	configScreen.listScroll, "BOTTOMLEFT", 0, 10)
	function configScreen.delButton.Event:LeftClick()
		index=configScreen.listContent:GetSelectedIndex()
		Equalizer.Datamodel.deleteWatchListIndex(index)
	end

	configScreen.addButton = UI.CreateFrame("RiftButton", "rbadd", configScreen.mainWindow:GetContent())
	configScreen.addButton:SetText(L("Save"))
	configScreen.addButton:SetPoint("TOPRIGHT",	configScreen.helpScroll, "BOTTOMRIGHT", 0, 10)
	function configScreen.addButton.Event:LeftClick()
		index=configScreen.listContent:GetSelectedIndex()
		if (index==nil) then
			Equalizer.Datamodel.addWatchList(
				configScreen.selectwb:GetText(),
				configScreen.textms:GetText(),
				configScreen.selectot:GetText(),
				configScreen.selectab:GetText())
		else
			Equalizer.Datamodel.setWatchList(index,
				configScreen.selectwb:GetText(),
				configScreen.textms:GetText(),
				configScreen.selectot:GetText(),
				configScreen.selectab:GetText())
		end
	end
	
	configScreen.upButton = UI.CreateFrame("RiftButton", "rbup", configScreen.mainWindow:GetContent())
--	configScreen.upButton:SetWidth(50)
	configScreen.upButton:SetText(L("Up"))
	configScreen.upButton:SetPoint("TOPRIGHT",	configScreen.listScroll, "BOTTOMRIGHT", 0, 10)
	function configScreen.upButton.Event:LeftClick()
		index=configScreen.listContent:GetSelectedIndex()
		if index and Equalizer.Datamodel.moveItemUp(index) then
			configScreen.listContent:SetSelectedIndex(index-1)
		elseif index then
			configScreen.listContent:SetSelectedIndex(index)
		end
	end
	
	configScreen.dnButton = UI.CreateFrame("RiftButton", "rbdn", configScreen.mainWindow:GetContent())
--	configScreen.dnButton:SetWidth(50)
	configScreen.dnButton:SetText(L("Down"))
--	configScreen.dnButton:SetPoint("TOPRIGHT",	configScreen.upbutton, "TOPLEFT", 10, 0)
	configScreen.dnButton:SetPoint("TOPRIGHT",	configScreen.listScroll, "BOTTOMRIGHT", -100, 10)
	function configScreen.dnButton.Event:LeftClick()
		index=configScreen.listContent:GetSelectedIndex()
		if index and Equalizer.Datamodel.moveItemDown(index) then
			configScreen.listContent:SetSelectedIndex(index+1)
		elseif index then
			configScreen.listContent:SetSelectedIndex(index)
		end
	end
	
	-- we do this here to fill the right side according to what's selected
	configScreen.listContent:SetSelectedIndex(1)
end

function Equalizer.UI.showConfigScreen()
	populateHelplist=nil
	helplistTarget=nil
	Equalizer.UI.emptyList()
	configScreen.mainWindow:SetVisible(true)
end

function Equalizer.UI.hideConfigScreen()
	configScreen.mainWindow:SetVisible(false)
end

local lastKnownBuffs = {}
local buffNameList
function Equalizer.UI.setListOfKnownBuffs(buffs)
	if (buffs) then
		lastKnownBuffs=buffs
		buffNameList=nil
	end
	if (populateHelplist == Equalizer.UI.getListOfKnownBuffs) then
		populateHelplist()
	end
end

function Equalizer.UI.getListOfKnownBuffs()
	if buffNameList == nil then
		buffNameList={}
		for k,v in pairs(lastKnownBuffs) do
			-- we only want to show buffs with non-nil duration
			if v.duration then
				str=v.name
				table.insert(buffNameList, str)
			end
		end
		table.insert(buffNameList, L("* Life"))
		table.insert(buffNameList, L("* Mana"))
		table.insert(buffNameList, L("---------------"))
		table.sort(buffNameList)
	end
	configScreen.helpContent:SetItems(buffNameList)
end

local lastKnownAbilities = {}
local abilityNameList
function Equalizer.UI.setListOfKnownAbilities(abilities)
	if (abilities) then
		lastKnownAbilities=abilities
		abilityNameList=nil
	end
	if (populateHelplist == Equalizer.UI.getListOfKnownAbilities) then
		populateHelplist()
	end
end

function Equalizer.UI.getListOfKnownAbilities()
	if abilityNameList == nil then
		abilityNameList={}
		for k,v in pairs(lastKnownAbilities) do
			str = v.name
			table.insert(abilityNameList, str)
		end
		table.sort(abilityNameList)
	end
	configScreen.helpContent:SetItems(abilityNameList)
end

function Equalizer.UI.emptyList()
	configScreen.helpContent:SetItems({})
end

function Equalizer.UI.getListOfKnownTargets()
	local targetNames={"player", "player.target", "player.target.target",
			   "player.pet",
			   "focus", "focus.target", "focus.target.target",
--			   "mouseover",
			   }
	table.sort(targetNames)
	configScreen.helpContent:SetItems(targetNames)
end

-- ==========================================================
-- ========== handle buff watcher window ====================
-- ==========================================================

local bg, ai, fg
local function initBackground(index)
	bg=buffWatcher.barBackgrounds[index]
	bg:ClearAll()
	if Equalizer_Settings.vertical then
		bg:SetPoint("BOTTOMLEFT", buffWatcher.mainWindow, "BOTTOMLEFT", 2, -(index-1)*Equalizer_Settings.buttonsize-2)
		bg:SetHeight(Equalizer_Settings.buttonsize)
		bg:SetWidth(Equalizer_Settings.barheight)
	else
		bg:SetPoint("BOTTOMLEFT", buffWatcher.mainWindow, "BOTTOMLEFT", (index-1)*Equalizer_Settings.buttonsize+2, -2)
		bg:SetWidth(Equalizer_Settings.buttonsize)
		bg:SetHeight(Equalizer_Settings.barheight)
	end
	bg:SetBackgroundColor(0.3, 0.3, 0.3, Equalizer_Settings.bgAlpha)
	bg:SetSecureMode("restricted")
end

local function initIcon(index)
	ai=buffWatcher.abilityIcons[index]
	ai:ClearAll()
	if Equalizer_Settings.vertical then
		ai:SetPoint("TOPRIGHT", bg, "TOPLEFT", (Equalizer_Settings.buttonsize-2), 1)
		ai:SetPoint("BOTTOMLEFT", bg, "BOTTOMLEFT", -1, -1)
	else
		ai:SetPoint("TOPLEFT", bg, "BOTTOMLEFT", 1, -(Equalizer_Settings.buttonsize-2))
		ai:SetPoint("BOTTOMRIGHT", bg, "BOTTOMRIGHT", -1, -1)
	end
	ai:SetBackgroundColor(0, 0, 0.7, 1)
	ai:SetSecureMode("restricted")
end

local function initBar(index)
	fg=buffWatcher.barForegrounds[index]
	fg:ClearAll()
	if Equalizer_Settings.vertical then
		fg:SetPoint("TOPLEFT", ai, "TOPRIGHT", 0, 0)
		fg:SetHeight(Equalizer_Settings.buttonsize-2)
		fg:SetWidth(Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)
	else
		fg:SetPoint("BOTTOMLEFT", ai, "TOPLEFT", 0, 0)
		fg:SetWidth(Equalizer_Settings.buttonsize-2)
		fg:SetHeight(Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)
	end
	fg:SetBackgroundColor(0.1, 0.9, 0.1, 1)
	buffWatcher.barForegrounds[index] = fg
end

local function ensurebarsbuilt(index)
	if not buffWatcher.barBackgrounds[index] then
		buffWatcher.barBackgrounds[index] = UI.CreateFrame("Frame", "buffwatcherbg"..index, buffWatcher.mainWindow)
		initBackground(index)
	end
	bg = buffWatcher.barBackgrounds[index]
	if not buffWatcher.abilityIcons[index] then
		buffWatcher.abilityIcons[index]=UI.CreateFrame("Texture", "buffwatcherabil"..index, bg)
		initIcon(index)
	end
	if not buffWatcher.barForegrounds[index] then
		buffWatcher.barForegrounds[index]=UI.CreateFrame("Frame", "buffwatcherfg"..index, bg)
		initBar(index)
	end
	if buffWatcher.usedBars < index then
		buffWatcher.usedBars = index
	end
end

local function adjustNumberOfBars()
	nBars=Equalizer.Datamodel.getWatchlistCount()
	local neededSize = 4
	
	if nbars==0 then
		buffWatcher.mainWindow:SetVisible(false)
	else
		buffWatcher.mainWindow:SetVisible(true)
	end
	for i=1,nBars,1 do
		local def=Equalizer.Datamodel.getWatchListIndex(i)
		ensurebarsbuilt(i)
		buffWatcher.abilityIcons[i]:SetVisible(true)
		-- buffWatcher.abilityIcons[i].Event.LeftDown="say cast @"..def.target.." "..def.ability.."\ncast @"..def.target.." "..def.ability.."\n"
		buffWatcher.abilityIcons[i].Event.LeftDown="cast @"..def.target.." "..def.ability.."\n"
		if (Equalizer_Session.debug) then
			print (def.icon or "unknown icon")
		end
		buffWatcher.barBackgrounds[i]:SetVisible(true)
		buffWatcher.barForegrounds[i]:SetVisible(true)

		if def.buff:sub(1, 1) ~= "-" then
			buffWatcher.abilityIcons[i]:SetTexture("Rift", def.icon or "xxx.dds")
			neededSize = neededSize + Equalizer_Settings.buttonsize
		else
			buffWatcher.abilityIcons[i]:SetTexture("Rift", "xxx.dds")
			neededSize = neededSize + Equalizer_Settings.buttonsize --@@@ later: separator width
		end
	end
	for i=nBars+1,buffWatcher.usedBars,1 do
		if (Equalizer_Session.debug) then
			print ("set "..i.." invisible")
		end
		buffWatcher.abilityIcons[i]:SetVisible(false)
		buffWatcher.barBackgrounds[i]:SetVisible(false)
		buffWatcher.barForegrounds[i]:SetVisible(false)
	end
	
	if Equalizer_Settings.vertical then
		buffWatcher.mainWindow:SetHeight(neededSize)
		buffWatcher.mainWindow:SetWidth(Equalizer_Settings.barheight+4)
	else
		buffWatcher.mainWindow:SetWidth(neededSize)
		buffWatcher.mainWindow:SetHeight(Equalizer_Settings.barheight+4)
	end
end

local function buildBuffWatcher()
	buffWatcher.mainWindow=UI.CreateFrame("Frame", "buffwatcher", context)	
	buffWatcher.mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Equalizer_Settings.xpos, Equalizer_Settings.ypos)
	buffWatcher.mainWindow:SetVisible(true)
	buffWatcher.mainWindow:SetSecureMode("restricted")
	buffWatcher.mainWindow.state = {}
	buffWatcher.usedBars = 0
	buffWatcher.abilityIcons = {}
	buffWatcher.barBackgrounds = {}
	buffWatcher.barForegrounds = {}
	adjustNumberOfBars()
	
	function buffWatcher.mainWindow.Event:LeftDown()
		if Equalizer.secureMode 
		or Equalizer_Settings.locked then
			return
		end

		buffWatcher.mainWindow.state.mouseDown = true
		local mouse = Inspect.Mouse()
		buffWatcher.mainWindow.state.startX = buffWatcher.mainWindow:GetLeft()
		buffWatcher.mainWindow.state.startY = buffWatcher.mainWindow:GetTop()
		buffWatcher.mainWindow.state.mouseStartX = mouse.x
		buffWatcher.mainWindow.state.mouseStartY = mouse.y
		buffWatcher.mainWindow:SetBackgroundColor(0.5, 0.5, 0.5, Equalizer_Settings.bgAlpha)
	end

	function buffWatcher.mainWindow.Event:MouseMove()
		if buffWatcher.mainWindow.state.mouseDown then
			local mouse = Inspect.Mouse()
			Equalizer_Settings.xpos=mouse.x - buffWatcher.mainWindow.state.mouseStartX + buffWatcher.mainWindow.state.startX
			Equalizer_Settings.ypos=mouse.y - buffWatcher.mainWindow.state.mouseStartY + buffWatcher.mainWindow.state.startY
			buffWatcher.mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT",
				Equalizer_Settings.xpos, Equalizer_Settings.ypos)
		end
	end

	function buffWatcher.mainWindow.Event:LeftUp()
		if buffWatcher.mainWindow.state.mouseDown then
			buffWatcher.mainWindow.state.mouseDown = false
			buffWatcher.mainWindow:SetBackgroundColor(0, 1, 0, Equalizer_Settings.bgAlpha)
		end
	end

	if EqualizerSettings and EqualizerSettings.debug then
		print ("buffWatcher built")
	end
end

function Equalizer.UI.periodicUpdate()
	if playerID == nil or playerID == "player" then
		local temp=Inspect.Unit.Detail("player")
		if temp and temp.id then
			playerID = temp.id
			-- print("got player ID "..playerID)
		end
	end
	buffcache={}
	nBars=Equalizer.Datamodel.getWatchlistCount()
	for i=1,nBars,1 do
		local found=nil
		local foundself=nil
		local foundother=nil
		def=Equalizer.Datamodel.getWatchListIndex(i)
		ensurebarsbuilt(i)
		if def.buff:sub(1, 1) == "*" then
			local target = Inspect.Unit.Detail(def.target)
			if target and def.buff == L("* Life") then
				found = { ["duration"] = target.healthMax or 1, ["remaining"] = target.health or 0 }
				foundself = true
			elseif target and def.buff == L("* Mana") then
				found = { ["duration"] = target.manaMax or 1, ["remaining"] = target.mana or 0 }
				foundself = true
			end
		elseif def.buff:sub(1, 1) == "-" then
			found = { ["duration"] = 1 }
		else
			if not buffcache[def.target] then
				buffs=Inspect.Buff.List(def.target);
				if buffs then
					buffcache[def.target]=Inspect.Buff.Detail(def.target, buffs)
				end
			end
			if buffcache[def.target] then
				for k,v in pairs(buffcache[def.target]) do
					if v.name == def.buff then
						-- print ("buff by " .. v.caster .. " player id = "..playerID)
						if v.caster==playerID then
							foundself=v
							break
						elseif (foundother==nil or foundother.remaining < v.remaining) then
							foundother=v
						end
					end
				end
			end
			if foundother then found=foundother end
			if foundself  then found=foundself  end
		end
		if found then
			if (def.stacks > 1) then
				width=Equalizer_Settings.buttonsize*((found.stack or 1)/def.stacks)
			else
				width=Equalizer_Settings.buttonsize
			end
			if Equalizer_Settings.vertical then
				buffWatcher.barForegrounds[i]:SetHeight(width-2)
			else
				buffWatcher.barForegrounds[i]:SetWidth(width-2)
			end
			if found.remaining then
				local base, range, pos, red, green, blue, alpha
				if Equalizer_Settings.vertical then
					buffWatcher.barForegrounds[i]:SetWidth((Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)*
											(math.log(1+found.remaining/found.duration)/0.7))
				else
					buffWatcher.barForegrounds[i]:SetHeight((Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)*
											(math.log(1+found.remaining/found.duration)/0.7))
				end
				if (found.remaining > found.duration * 0.3) then		-- 100..30
					base=found.duration*0.3					-- 30
					range=found.duration*0.7				-- 70
					pos=found.remaining-base				-- 70..0
					red=1-(pos/range)					-- 1 - (1..0) = (0..1)
					green=1
					blue=0
				elseif (found.remaining > found.duration * 0.1) then
					base=found.duration*0.1					-- 10
					range=found.duration*0.2				-- 20
					pos=found.remaining-base				-- 20..0
					red=1
					green=(pos/range)					-- 1..0
					blue=0
				else
					red=1
					green=0
					blue=0
				end
				if foundself then
					alpha=1.0
				else
					alpha=Equalizer_Settings.othersAlpha
				end
				buffWatcher.barForegrounds[i]:SetBackgroundColor(red, green, blue, alpha)
			else
				if Equalizer_Settings.vertical then
					buffWatcher.barForegrounds[i]:SetWidth(Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)
				else
					buffWatcher.barForegrounds[i]:SetHeight(Equalizer_Settings.barheight-Equalizer_Settings.buttonsize)
				end
				buffWatcher.barForegrounds[i]:SetBackgroundColor(0, 0, 0.7, 1)
			end
			
		else
			if Equalizer_Settings.vertical then
				buffWatcher.barForegrounds[i]:SetHeight(1)
			else
				buffWatcher.barForegrounds[i]:SetWidth(1)
			end
			buffWatcher.barForegrounds[i]:SetBackgroundColor(1, 0, 1, 1)
		end
	end
end

-- ==========================================================
-- =============== generic UI functions  ====================
-- ==========================================================

local function createUI()
	context=UI.CreateContext("Equalizer")
	context:SetSecureMode("restricted")
	
	if (configScreen.built == false) then
		buildConfigScreen()
		configScreen.built=true
		Equalizer.UI.hideConfigScreen()
	end
	if (buffWatcher.built == false) then
		buildBuffWatcher()
		buffWatcher.built=true
	end
end

local WatchlistWasChanged=false
local LayoutWasChanged=false
local AlphaWasChanged=false

function Equalizer.UI.triggerAlphaChanged()
	if Equalizer.secureMode then
		print(L("Watchlist changes postponed till you leave combat"))
		AlphaWasChanged=true
	else
		AlphaWasChanged=false
		buffWatcher.mainWindow:SetBackgroundColor(0, 1, 0, Equalizer_Settings.bgAlpha)
		local nBars=Equalizer.Datamodel.getWatchlistCount()
		for i=1, nBars, 1 do
			bg=buffWatcher.barBackgrounds[i]
			bg:SetBackgroundColor(0.3, 0.3, 0.3, Equalizer_Settings.bgAlpha)
		end
	end
end

function Equalizer.UI.triggerWatchlistChanged()
	configScreen.listContent:SetSelectedIndex(nil)
	configScreen.listContent:SetItems(Equalizer.Datamodel.getWatchlistStrings())
	configScreen.listContent:SetSelectedIndex(0)
	if Equalizer.secureMode then
		print(L("Watchlist changes postponed till you leave combat"))
		WatchlistWasChanged=true
	else
		WatchlistWasChanged=false
		adjustNumberOfBars()
	end
end

function Equalizer.UI.triggerLayoutChanged()
	if Equalizer.secureMode then
		print(L("Layout changes postponed till you leave combat"))
		LayoutWasChanged=true
	else
		LayoutWasChanged=false
		nBars=Equalizer.Datamodel.getWatchlistCount()
		if Equalizer_Settings.vertical then
			buffWatcher.mainWindow:SetHeight(nBars*Equalizer_Settings.buttonsize+4)
			buffWatcher.mainWindow:SetWidth(Equalizer_Settings.barheight+4)
		else
			buffWatcher.mainWindow:SetWidth(nBars*Equalizer_Settings.buttonsize+4)
			buffWatcher.mainWindow:SetHeight(Equalizer_Settings.barheight+4)
		end
		for i=1,nBars,1 do
			initBackground(i)
			initIcon(i)
			initBar(i)
		end
	end
end

function Equalizer.UI.triggerRoleChanged()
	configScreen.mainWindow:SetTitle(L("Equalizer Configuration: Role ")..Equalizer_Settings.currentRole)
end

function Equalizer.UI.secureModeEntered()
	buffWatcher.mainWindow:SetBackgroundColor(1, 0, 0, Equalizer_Settings.bgAlpha)
end

function Equalizer.UI.secureModeExited()
	buffWatcher.mainWindow:SetBackgroundColor(0, 1, 0, Equalizer_Settings.bgAlpha)
	if (WatchlistWasChanged) then Equalizer.UI.triggerWatchlistChanged() end
	if (LayoutWasChanged) then Equalizer.UI.triggerLayoutChanged() end
	if (AlphaWasChanged) then Equalizer.UI.triggerAlphaChanged() end
end


function Equalizer.AddonLoaded(addon)
	LibVersionCheck.register("Equalizer", Equalizer.Version)
	if (addon == "Equalizer") then
		print ( L("Equalizer Version ")..Equalizer.Version.. L(" installed!") )
		createUI()
	end
end

table.insert(Event.Addon.Load.End, { Equalizer.AddonLoaded, "Equalizer", "AddonLoaded" })
